package cn.com.infosec.crypto.generators;

import cn.com.infosec.crypto.AsymmetricCipherKeyPair;
import cn.com.infosec.crypto.AsymmetricCipherKeyPairGenerator;
import cn.com.infosec.crypto.KeyGenerationParameters;
import cn.com.infosec.crypto.params.DSAKeyGenerationParameters;
import cn.com.infosec.crypto.params.DSAParameters;
import cn.com.infosec.crypto.params.DSAPrivateKeyParameters;
import cn.com.infosec.crypto.params.DSAPublicKeyParameters;
import java.math.BigInteger;
import java.security.SecureRandom;

public class DSAKeyPairGenerator implements AsymmetricCipherKeyPairGenerator {
   private static final BigInteger ZERO = BigInteger.valueOf(0L);
   private DSAKeyGenerationParameters param;

   public void init(KeyGenerationParameters param) {
      this.param = (DSAKeyGenerationParameters)param;
   }

   public AsymmetricCipherKeyPair generateKeyPair() {
      DSAParameters var1;
      DSAParameters var10000 = var1 = this.param.getParameters();
      SecureRandom var6 = this.param.getRandom();
      BigInteger var2 = var10000.getQ();
      BigInteger var3 = var10000.getP();
      BigInteger var4 = var10000.getG();

      BigInteger var5;
      BigInteger var10;
      do {
         do {
            var10 = var5 = new BigInteger;
            var10.<init>(160, var6);
         } while(var10.equals(ZERO));
      } while(var5.compareTo(var2) >= 0);

      BigInteger var7 = var4.modPow(var5, var3);
      DSAPublicKeyParameters var9;
      var9 = new DSAPublicKeyParameters.<init>(var7, var1);
      DSAPrivateKeyParameters var8;
      var8 = new DSAPrivateKeyParameters.<init>(var5, var1);
      return new AsymmetricCipherKeyPair(var9, var8);
   }
}
